Index: /trunk/src/sh_readconf.c
===================================================================
--- /trunk/src/sh_readconf.c	(revision 584)
+++ /trunk/src/sh_readconf.c	(revision 1)
@@ -1295,18 +1053,7 @@
     sh_log_set_facility },
 
-  { N_("syslogmapstampto"),    SH_SECTION_LOG,   SH_SECTION_MISC, 
-    sh_log_set_stamp_priority },
-
   { N_("mactype"),     SH_SECTION_MISC,  SH_SECTION_NONE, 
     sh_util_sigtype },
 
-  { N_("avoidblock"),     SH_SECTION_MISC,  SH_SECTION_NONE, 
-    sh_calls_set_sub },
-
-#ifdef SCREW_IT_UP
-  { N_("setsigtrapmaxduration"),        SH_SECTION_MISC,  SH_SECTION_MISC, 
-    sh_sigtrap_max_duration_set },
-#endif
-
   { NULL,    0,   0,  NULL}
 };
@@ -1316,8 +1063,6 @@
 
 static int sh_readconfig_line (char * line)
-{
-  char * key;
-  const char * value;
-  char * value_dup;
+{    
+  char * c;
   char * tmp;
   int    i;
@@ -1328,15 +1073,5 @@
 #endif
 
-  static const char  *dummy = N_("dummy");
-
-  static const char  *closing[] = {
-    N_("closecommand"),
-    N_("closeaddress"),
-    N_("logmonendgroup"),
-    N_("logmonendhost"),
-    NULL
-  };
-
-  static const char  *ident[] = {
+  static char  *ident[] = {
     N_("severityreadonly"),
     N_("severitylogfiles"),
@@ -1350,7 +1085,4 @@
     N_("severityuser0"),
     N_("severityuser1"),
-    N_("severityuser2"),
-    N_("severityuser3"),
-    N_("severityuser4"),
     N_("severityprelink"),
     NULL
@@ -1369,7 +1101,4 @@
     SH_ERR_T_USER0,       
     SH_ERR_T_USER1,       
-    SH_ERR_T_USER2,       
-    SH_ERR_T_USER3,       
-    SH_ERR_T_USER4,       
     SH_ERR_T_PRELINK,       
   };
@@ -1377,50 +1106,10 @@
   SL_ENTER(_("sh_readconf_line"));
 
-  /* convert to lowercase                              */
-
-  tmp = line;
-  while (*tmp != '=' && *tmp != '\0')
-    {
-      *tmp = tolower( (int) *tmp);
-      ++tmp;
-    }
-
-  key = line;
-
   /* interpret line                                    */
 
-  value = strchr(line, '=');
-
-  if (value == NULL || (*value) == '\0')
-    {
-      if (key != NULL)
-	{
-	  i = 0;
-	  while (closing[i] != NULL) 
-	    {
-	      if (sl_strncmp(key,_(closing[i]),sl_strlen(closing[i])-1) == 0)
-		{
-		  value = dummy;
-		  goto ok_novalue;
-		}
-	      ++i;
-	    }
-
-	  TPT(( 0, FIL__, __LINE__, _("msg=<ConfigFile: not key=value: %s>\n"),
-		line));
-	}
-      SL_RETURN(good_opt, _("sh_readconf_line"));
-    }
-  else
-    ++value;
-
-  /* skip leading whitespace
-   */
-  while ((*value) == ' ' || (*value) == '\t')
-    ++value;
-
-  if ((*value) == '\0')     /* no value                    */
-    {
-      if (key != NULL)
+  c = strchr(line, '=');
+  if (c == NULL || (*c) == '\0')
+    {
+      if (line != NULL)
 	{
 	  TPT(( 0, FIL__, __LINE__, _("msg=<ConfigFile: not key=value: %s>\n"),
@@ -1429,6 +1118,30 @@
       SL_RETURN(good_opt, _("sh_readconf_line"));
     }
-
- ok_novalue:
+  else
+    ++c;
+
+  /* skip leading whitespace
+   */
+  while ((*c) == ' ' || (*c) == '\t')
+    ++c;
+
+  if ((*c) == '\0')     /* no value                    */
+    {
+      if (line != NULL)
+	{
+	  TPT(( 0, FIL__, __LINE__, _("msg=<ConfigFile: not key=value: %s>\n"),
+		line));
+	}
+      SL_RETURN(good_opt, _("sh_readconf_line"));
+    }
+
+  /* convert to lowercase                              */
+
+  tmp = line;
+  while (*tmp != '=')
+    {
+      *tmp = tolower( (int) *tmp);
+      ++tmp;
+    }
 
   if (!sl_is_suid())
@@ -1437,18 +1150,4 @@
     }
 
-  /* Expand shell expressions. This return allocated memory which we must free.
-   * If !defined(SH_EVAL_SHELL), this will reduce to a strdup.
-   */
-  value_dup = sh_readconf_expand_value(value);
-
-  if (!value_dup || (*value_dup) == '\0')
-    {
-      TPT(( 0, FIL__, __LINE__, 
-	    _("msg=<ConfigFile: empty after shell expansion: %s>\n"),
-	    line));
-      SL_RETURN(good_opt, _("sh_readconf_line"));
-    }
-
-  value = value_dup;
 
 #if defined (SH_WITH_CLIENT) || defined (SH_STANDALONE) 
@@ -1460,12 +1159,12 @@
 	       ++modkey) 
 	    {
-	      if (sl_strncmp (key,
+	      if (sl_strncmp (line,   
 			      _(modList[modnum].conf_table[modkey].the_opt),
 			      sl_strlen(modList[modnum].conf_table[modkey].the_opt) ) == 0)
 		{
 		  good_opt = 0;
-		  if (0 != modList[modnum].conf_table[modkey].func(value))
+		  if (0 != modList[modnum].conf_table[modkey].func(c))
 		    sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_EINVALS,
-				     _(modList[modnum].conf_table[modkey].the_opt), value);
+				     _(modList[modnum].conf_table[modkey].the_opt), c);
 		  if (!sl_is_suid())
 		    {
@@ -1487,8 +1186,8 @@
       i = 0;
       while (ident[i] != NULL) {
-	if (sl_strncmp (key, _(ident[i]), sl_strlen(ident[i])) == 0)
+	if (sl_strncmp (line, _(ident[i]), sl_strlen(ident[i])-1) == 0)
 	  {
 	    good_opt = 0;
-	    sh_error_set_iv (identnum[i], value);
+	    sh_error_set_iv (identnum[i], c);
 	    break;
 	  }
@@ -1503,11 +1202,11 @@
 	  if ((ext_table[i].section == read_mode || 
 	       ext_table[i].alt_section == read_mode) &&
-	      sl_strncmp (key, _(ext_table[i].optname), 
+	      sl_strncmp (line, _(ext_table[i].optname), 
 			  sl_strlen(ext_table[i].optname)) == 0)
 	    {
 	      good_opt = 0;
-	      if (0 != ext_table[i].func (value))
+	      if (0 != ext_table[i].func (c))
 		sh_error_handle ((-1), FIL__, __LINE__, 0, MSG_EINVALS,
-				 _(ext_table[i].optname), value);
+				 _(ext_table[i].optname), c);
 	      break;
 	    }
@@ -1516,8 +1215,6 @@
     }
 
-  SH_FREE(value_dup);
-
   SL_RETURN(good_opt, _("sh_readconf_line"));
 }
-
+  
     
Index: /trunk/src/sh_schedule.c
===================================================================
--- /trunk/src/sh_schedule.c	(revision 584)
+++ /trunk/src/sh_schedule.c	(revision 1)
@@ -42,12 +42,16 @@
 #endif
 
+#if TIME_WITH_SYS_TIME
+#include <sys/time.h>
+#include <time.h>
+#else
 #if HAVE_SYS_TIME_H
 #include <sys/time.h>
-#endif
+#else
 #include <time.h>
-
-#include "samhain.h"
+#endif
+#endif
+
 #include "sh_mem.h"
-#include "sh_error_min.h"
 
 /* TESTONLY */
@@ -125,7 +129,4 @@
   struct tm * tval;
   int count, i, nval;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  struct tm     time_tm;
-#endif
 
   if (!isched)
@@ -133,16 +134,5 @@
 
   now  = time(NULL);
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_LOCALTIME_R)
-  tval = localtime_r(&now, &time_tm);
-#else
   tval = localtime(&now);
-#endif
-
-  if (!tval)
-    {
-      sh_error_handle ((-1), FIL__, __LINE__, errno, MSG_E_SUBGEN,
-                       _("localime() failed"), _("test_sched_int") );
-      return 0;
-    }
 
   count = 0;
@@ -215,5 +205,5 @@
 	/*@+charint@*//* Incompatible types for == (char, char): ??? */
 	for (k = 0; k < 3; ++k)
-	  if (p[k] != '\0' && tolower((int) p[k]) == MonNames[j][k]) ++l;
+	  if (p[k] != '\0' && tolower(p[k]) == MonNames[j][k]) ++l;
 	/*@-charint@*/
 	if (l == 3)
@@ -227,5 +217,5 @@
 	/*@+charint@*//* Incompatible types for == (char, char): ??? */
 	for (k = 0; k < 3; ++k)
-	  if (p[k] != '\0' && tolower((int) p[k]) == DayNames[j][k]) ++l;
+	  if (p[k] != '\0' && tolower(p[k]) == DayNames[j][k]) ++l;
 	/*@-charint@*/
 	if (l == 3)
@@ -328,26 +318,16 @@
   char * copy;
   int    i = 0;
-  size_t len;
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-  char * saveptr;
-#endif
 
   if (!ssched || !isched)
     return -1;
 
-  len = strlen(ssched)+1;
 #ifdef TESTONLY
-  copy = calloc(1,len);                 /* testonly code */
-#else
-  copy = SH_ALLOC(len);
-#endif
-  sl_strlcpy(copy, ssched, len);
-
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-  p = strtok_r(copy, " \t", &saveptr); /* parse crontab-style schedule */
-#else
+  copy = malloc(strlen(ssched)+1);                 /* testonly code */
+#else
+  copy = SH_ALLOC(strlen(ssched)+1);
+#endif
+  strcpy(copy, ssched);                            /* known to fit  */
+
   p = strtok(copy, " \t"); /* parse crontab-style schedule */
-#endif
-
   if (!p)
     goto err; 
@@ -357,9 +337,5 @@
   for (i = 1; i < 5; ++i)
     {
-#if defined(HAVE_PTHREAD) && defined (_POSIX_THREAD_SAFE_FUNCTIONS) && defined(HAVE_STRTOK_R)
-      p = strtok_r(NULL, " \t", &saveptr); /* parse crontab-style schedule */
-#else
       p = strtok(NULL, " \t"); /* parse crontab-style schedule */
-#endif
       if (!p)
 	goto err; 
@@ -367,4 +343,10 @@
 	goto err;
     }
+
+  /*
+  for (i = 0; i < 5; ++i)
+    printf("%2d MIN  %3d  MAX  %3d  STEP  %3d\n", 
+	   i, isched->min[i], isched->max[i], isched->step[i]);
+  */
 
   isched->last_exec = (time_t)-1;
@@ -441,5 +423,5 @@
     {
       if (test_sched(&isched))
-	printf("EXECUTE  at: %s", ctime(&(isched.last_exec))); /* TESTONLY */
+	printf("EXECUTE  at: %s", ctime(&(isched.last_exec)));
       sleep (1); /* TESTONLY */
     }
